## fweb 1.62

=== Web/Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 #    (1) If you are a Unix user, do the following:
 
-#		cd web
+#		cd Web
 #		./configure [--prefix=path] [--exec-prefix=path]
 # (This generates the following files appropriate to your system:
 #	defaults.mk from defaults.mk.in;
@@ -137,7 +137,7 @@
 	$(TOUCH) $(WEB)/typedefs.hweb $(WEB)/*.h $(WEB)/*.c 
 
 # --- This entry makes both FWEB processors from the FWEB sources. ---
-both: ftangle fweave
+both: ftangle fweave idxmerge
 
 # --- The ``make bootstrap'' command assumes that the WEB files are there.
 # However, if you're just compiling you shouldn't need the WEB files.  In the
@@ -272,7 +272,8 @@
 $(WEB)/d_type.h: $(D_TYPE_WEB)
 	./ftangle $(WEB)/d_type $(OPTIONS)
 
-RESERVED_WEB = $(WEB)/reserved.web $(COMMON_HWEB)
+RESERVED_WEB = $(WEB)/reserved.web $(COMMON_HWEB)\
+	 $(WEB)/ccodes.$(HWEB) $(WEB)/xrefs.$(HWEB)
 
 $(WEB)/reserved.c: $(RESERVED_WEB)
 	./ftangle $(WEB)/reserved $(OPTIONS)
@@ -397,4 +398,3 @@
 	$(LINK) ftangle$(OBJ) $(FTANGLE2) $(FTANGLE3)\
 		common$(OBJ) $(COMMON2)\
 		reserved$(OBJ) $(RESERVED2)\
-		ratfor$(LOAD_RATFOR)$(OBJ) $(RATFOR2)\
