=== debian/changelog ===
fweb (1.62-13) unstable; urgency=medium

  * Use dh_installtex and remove old postinst/postrm contents,
    build-depend on tex-common (Closes: #821829).
  * Fix homepage link.
  * Fixed download URL in copyright file not to include (old) filename.
  * Add a debian/watch file.
  * Bumped Standards-Version to 3.9.7, removed dependency on install-info.

 -- Yann Dirson <dirson@debian.org>  Sat, 04 Jun 2016 16:44:43 +0200

fweb (1.62-12) unstable; urgency=low

  * Acknowledge NMU.
  * Further fix fweb-doc extended description.
  * Fix texi.info for compatibility with makeinfo 5.1 (Closes: #712333):
    * drop apparently-nonsensical @def@ifhtml
    * don't include @if(tex|info) inside @macro defs
    * add @ifhtml implementation of conditional @macro defs
    * fix subsection nesting level where needed
  * Fix texi.info direntry specification (lintian).

 -- Yann Dirson <dirson@debian.org>  Mon, 19 Aug 2013 21:59:54 +0200

fweb (1.62-11.1) unstable; urgency=low

  * Non-maintainer upload.
    - Move to packaging format "3.0 (quilt)".
  * debian/compat
    - Update to 8.
  * debian/control
    - (Build-Depends): update to debhelper 8.
    - (Description): Adjust first line (lintian).
    - (Homepage): Add.
    - (Recommends): Change to tetex-base to texlive (Closes: #601268).
    - (Standards-Version): Update to 3.9.2.
    - (Suggests): Remove tetex-base.
    Package fweb-doc
    - (Description): Extend first line (Lintian).
    - (Depends): Add ${misc:Depends}, add dpkg (>= 1.15.4) | install-info
    - (Section): Add doc.
  * debian/copyright
    - Remove obsolete FSF address. Correct GPL path.
  * debian/idxmerge.1
    - Fix hyphen-used-as-minus-sign (Lintian).
  * debian/patches
    - New. Convert embedded changes to upstream code into individual patches.
  * debian/rules
    - Replace obsolete dh_clean with dh_prep
    - (build-arch, build-indep): New (W: Lintian).
    - (clean): Adjust make call Web/Makefile (Lintian).
      Delete generated files: Web/fweave.mds Web/fweave.ndx
    - (docdir): Install docs to $package-doc.
    - (infodir): New variable.
    - (install): Don't create directory doc-base (lintian).
      Don't create empty info dir (Lintian).
    - (tmpdir): Install to $package, not tmp dir thus no longer needing
      dh_movefiles.
  * debian/source/format
    - New file.
  * fweb-doc.doc-base
    - (Section): Update from Apps/Programming to Programming.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 18 Nov 2011 21:05:43 +0200

fweb (1.62-11) unstable; urgency=low

  * Fixed Web/Makefile not to depend on the number of splitted info files
    (Closes: #203430).
  * Use dhbuildinfo.

 -- Yann Dirson <dirson@debian.org>  Wed, 27 Aug 2003 09:14:36 +0200

fweb (1.62-10) unstable; urgency=low

  * Rebuilt with current debhelper to conform to new /usr/doc policy
    (lintian).
  * Changed build options and support "noopt" instead of "debug" flag.
  * Bounced Standards-Version to 3.5.10.
  * Use debian/compat, build-dep on debhelper 3.4.4 or greater.
  * Improved description for fweb-doc (Closes: #128253).

 -- Yann Dirson <dirson@debian.org>  Sun,  1 Jun 2003 17:16:16 +0200

fweb (1.62-9) unstable; urgency=low

  * The "Fifth anniversary (nearly)" release !
  * Spelling in description (Closes: #12465).
  * Spelling in copyright (lintian).
  * Workaround in texi doc so that "makeinfo --html" can work - texi2html
    still does not (still many warnings).  Brought doc-base file from the
    attic.
  * DEB_BUILD_OPTIONS support.
  * Bounced Standards-Version to 3.5.6.
  * Modernized debian/rules, debhelper v3.
  * Split doc in its own package.

 -- Yann Dirson <dirson@debian.org>  Fri,  4 Jan 2002 23:20:22 +0100

fweb (1.62-8) unstable; urgency=medium

  * Reported NMU fix in source file (Closes: #103151).
  * Completed build-depend control field (Closes: #104386, #86158).
  * Added category info to texinfo doc.

 -- Yann Dirson <dirson@debian.org>  Wed,  1 Aug 2001 01:09:29 +0200

fweb (1.62-7.1) unstable; urgency=low
  * Non-maintainer upload.
  * Fix printf-is-a-macro issue (gcc 3.0).  Closes: #103151

 -- LaMont Jones <lamont@debian.org>  Mon,  9 Jul 2001 21:39:34 -0600

fweb (1.62-7) unstable; urgency=low

  * Added Build-depends: texinfo (Closes: #84611).
  * Do not convert texi to HTML, conversion now fails.

 -- Yann Dirson <dirson@debian.org>  Sun,  4 Feb 2001 22:42:42 +0100

fweb (1.62-6) unstable; urgency=low

  * Build using "-g" as per policy.
  * Fix for infinite loop when using single-letter @ commands in
    verbatim mode (Closes: #52702).
  * Regenerate common.c to really have 1.62 as version number.

 -- Yann Dirson <dirson@debian.org>  Tue, 14 Dec 1999 22:03:20 +0100

fweb (1.62-5) unstable; urgency=low

  * Moved man, doc, info to /usr/share as per FHS.
  * Some debian/rules cleanups.
  * Bumped Standards-Version to 3.0.1.

 -- Yann Dirson <dirson@debian.org>  Sun, 24 Oct 1999 17:58:10 +0200

fweb (1.62-4) unstable; urgency=low

  * Applied patch from Hartmut Koptein to allow compilation with glibc
    2.1 (Closes: Bug#37302 -- Bug#29535 was closed but -4 had not yet been
    released).
  * Moved latex style file from /usr/lib/ to /usr/share/ (Closes:
    Bug#40439).
  * Fixed the version string saying "1.61" instead of "1.62".
  * Some debian/rules cleanup

 -- Yann Dirson <dirson@debian.org>  Tue, 29 Jun 1999 21:32:30 +0200

fweb (1.62-3) frozen unstable; urgency=low

  * Check for texhash before trying to run it, as fweb doesn't depend
    on TeX (Fixes: Bug#28904).
  * Suppressed useless X- fields in debian/control.

 -- Yann Dirson <dirson@debian.org>  Thu, 12 Nov 1998 21:39:13 +0100

fweb (1.62-2) frozen unstable; urgency=low

  * Recompiled for ncurses 4.
  * Passed lintian 0.9.3.

 -- Yann Dirson <dirson@debian.org>  Tue,  3 Nov 1998 19:53:49 +0100

fweb (1.62-1) unstable; urgency=low

  * New upstream release (Fixes: Bug#26247).  Probably fixes Bug#25969
    and Bug#26122 as well, but I did not checked yet.

