=== debian/watch ===
version=4
opts="passive" \
ftp://ftp.pppl.gov/pub/fweb/fweb-(\d.*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
